; this code computes sin(x)

	INCLUDE EFR32MG12.inc		; CPU register definitions
	EXPORT	main	
	
;-------------------------------------	; CODE segment in flash (ROM) 
	AREA    |.text|, CODE, READONLY
main	PROC				; main user code

	OORW	(0xF << 20), 0, CPACR	; enable FPU
	dsb				; sata synch barrier

	ldr	R0, =x
	vldr.f	S0, [R0]		; S0 = x
	bl	sin			; S0 = sin(x)
	
	nop				; examine the output here

loop	b	loop			; repeat periodic task		
	ENDP

;-------------------------------------
sin	PROC
	vpush.f	{S1 - S4}
	vmov.f	S1, S0			; S1 = x 
	vmul.f	S2, S1, S1		; S2 = x^2
	vmul.f	S4, S2, S1		; S4 = x*x^2
	vmov.f	S3, #6		
	vdiv.f	S4, S3			; S4 = x^3/3!	
	vsub.f	S0, S4			; S0 = x - x^3/3!
	vmul.f	S4, S2			; S4 = x^5/3!
	vldr.f	S3, =20
	vdiv.f	S4, S3			; S4 = x^5/5!
	vadd.f	S0, S4			; S0 = x - x^3/6 + x^5/120	
	vpop.f	{S1 - S4}
	bx	LR			; return
	ENDP
		
;-------------------------------------
	ALIGN
x	DCFS	0.1			; take sin of that angle in radians

	ALIGN
	END
	
	ALIGN
	END